#include <linux/config.h>
#include <linux/module.h>
#include <linux/smp.h>
#include <linux/string.h>
#include <linux/bios32.h>
#include <asm/qdma.h>
#include <asm/dio.h>
#include <asm/atomic.h>
#include <asm/bitops.h>
#include <asm/checksum.h>
#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/processor.h>
#include <asm/semaphore.h>
#include <asm/system.h>
#ifndef CONFIG_TCD
#include <asm/prom.h>
#include <asm/cuda.h>
#include <asm/pci-bridge.h>
#endif

EXPORT_SYMBOL(atomic_add);
EXPORT_SYMBOL(atomic_sub);
EXPORT_SYMBOL(atomic_inc);
EXPORT_SYMBOL(atomic_inc_return);
EXPORT_SYMBOL(atomic_dec);
EXPORT_SYMBOL(atomic_dec_return);
EXPORT_SYMBOL(atomic_dec_and_test);

EXPORT_SYMBOL(set_bit);
EXPORT_SYMBOL(clear_bit);
EXPORT_SYMBOL(change_bit);
EXPORT_SYMBOL(ffz);
EXPORT_SYMBOL(find_first_zero_bit);
EXPORT_SYMBOL(find_next_zero_bit);

EXPORT_SYMBOL(strcpy);
EXPORT_SYMBOL(strncpy);
EXPORT_SYMBOL(strcat);
EXPORT_SYMBOL(strncat);
EXPORT_SYMBOL(strchr);
EXPORT_SYMBOL(strrchr);
EXPORT_SYMBOL(strpbrk);
EXPORT_SYMBOL(strtok);
EXPORT_SYMBOL(strstr);
EXPORT_SYMBOL(strlen);
EXPORT_SYMBOL(strnlen);
EXPORT_SYMBOL(strspn);
EXPORT_SYMBOL(strcmp);
EXPORT_SYMBOL(strncmp);
EXPORT_SYMBOL(memset);
EXPORT_SYMBOL(memcpy);
EXPORT_SYMBOL(memmove);
EXPORT_SYMBOL(memscan);
EXPORT_SYMBOL(memcmp);

/* EXPORT_SYMBOL(csum_partial); already in net/netsyms.c */
EXPORT_SYMBOL(csum_partial_copy_generic);
EXPORT_SYMBOL(ip_fast_csum);
EXPORT_SYMBOL(csum_tcpudp_magic);


EXPORT_SYMBOL(__copy_tofrom_user);
EXPORT_SYMBOL(__clear_user);
EXPORT_SYMBOL(__strncpy_from_user);
EXPORT_SYMBOL(strlen_user);

#ifndef CONFIG_TCD
extern int ms_base_addr;
EXPORT_SYMBOL(ms_base_addr);
EXPORT_SYMBOL(cuda_request);
EXPORT_SYMBOL(cuda_send_request);
EXPORT_SYMBOL(adb_register);
#endif

#ifdef CONFIG_TCD
void make_page_present(unsigned long, int);
EXPORT_SYMBOL(make_page_present);

extern unsigned long ms_isr_cleared_g;
EXPORT_SYMBOL(ms_isr_cleared_g);
extern unsigned long  irq_ms_g;
EXPORT_SYMBOL(irq_ms_g);
#endif

#ifdef CONFIG_PREP
EXPORT_SYMBOL(inb);
EXPORT_SYMBOL(inw);
EXPORT_SYMBOL(inl);
EXPORT_SYMBOL(outb);
EXPORT_SYMBOL(outw);
EXPORT_SYMBOL(outl);
EXPORT_SYMBOL(outsl);
#endif

#ifdef CONFIG_PMAC
EXPORT_SYMBOL(nvram_readb);
EXPORT_SYMBOL(nvram_writeb);
#endif

EXPORT_SYMBOL(_insb);
EXPORT_SYMBOL(_outsb);
EXPORT_SYMBOL(_insw);
EXPORT_SYMBOL(_outsw);
EXPORT_SYMBOL(_insl);
EXPORT_SYMBOL(_outsl);
EXPORT_SYMBOL(ioremap);

EXPORT_SYMBOL(dump_thread);
EXPORT_SYMBOL(start_thread);

#ifdef CONFIG_PMAC
EXPORT_SYMBOL(abort);
EXPORT_SYMBOL(call_prom);
EXPORT_SYMBOL(find_devices);
EXPORT_SYMBOL(find_type_devices);
EXPORT_SYMBOL(find_path_device);
EXPORT_SYMBOL(get_property);
EXPORT_SYMBOL(note_scsi_host);
#endif

EXPORT_SYMBOL(__down_interruptible);

EXPORT_SYMBOL(cli);
EXPORT_SYMBOL(sti);
EXPORT_SYMBOL(__save_flags);
EXPORT_SYMBOL(__restore_flags);
EXPORT_SYMBOL(_disable_interrupts);
EXPORT_SYMBOL(_enable_interrupts);
EXPORT_SYMBOL(flush_instruction_cache);
EXPORT_SYMBOL(_get_PVR);
EXPORT_SYMBOL(giveup_fpu);
EXPORT_SYMBOL(store_cache_range);
EXPORT_SYMBOL(xchg_u32);

EXPORT_SYMBOL(DmaChInit);
EXPORT_SYMBOL(DmaChEnqueue);
EXPORT_SYMBOL(DmaChSetParameters);
EXPORT_SYMBOL(DmaChStart);
EXPORT_SYMBOL(DmaChStop);
EXPORT_SYMBOL(DmaChIdle);
EXPORT_SYMBOL(DmaChReqPrint);
EXPORT_SYMBOL(DmaChReqIsFinished);
EXPORT_SYMBOL(DmaChReqDioInit);
EXPORT_SYMBOL(DmaChReqDioGet);
EXPORT_SYMBOL(DmaChGetAddr);
EXPORT_SYMBOL(DmaChRingStart);
EXPORT_SYMBOL(DmaChRingStop);
EXPORT_SYMBOL(DmaChDebugPrint);
EXPORT_SYMBOL(DmaChDumpState);
extern void debug(char *, struct pt_regs *);
EXPORT_SYMBOL(debug);
#ifdef ALLOC_ILINK_DMA_BUFFERS
EXPORT_SYMBOL(ilink_dma_size);
EXPORT_SYMBOL(ilink_dma_buffers);
#endif

#ifndef CONFIG_TCD
EXPORT_SYMBOL(pcibios_present);
EXPORT_SYMBOL(pcibios_find_class);
EXPORT_SYMBOL(pcibios_find_device);
EXPORT_SYMBOL(pcibios_read_config_byte);
EXPORT_SYMBOL(pcibios_read_config_word);
EXPORT_SYMBOL(pcibios_read_config_dword);
EXPORT_SYMBOL(pcibios_write_config_byte);
EXPORT_SYMBOL(pcibios_write_config_word);
EXPORT_SYMBOL(pcibios_write_config_dword);
EXPORT_SYMBOL(pcibios_strerror);
#endif
#ifdef CONFIG_PMAC
EXPORT_SYMBOL(pci_io_base);
EXPORT_SYMBOL(pci_device_loc);
#endif
