/*$$$TIVO COPYRIGHT (Andy Goodman)$$$*/



#define min(x,y) (x)<(y)?(x):(y)


#ifdef TESTING
#include "qdma.h"
#include "dio.h"


#define PAGE_SIZE (1<<10)

#define PAGE_MASK ((~0)<<10)
static unsigned char *
Translate(U32 vaddr){
  return (unsigned char *)(vaddr+PAGE_SIZE);
}


#else


# include <linux/module.h>
# include <linux/sched.h>
# include <linux/kernel.h> /* printk() */
# include <linux/fs.h>     /* everything... */
# include <linux/errno.h>  /* error codes */
# include <linux/malloc.h>

# include <linux/ioport.h>
# include <linux/interrupt.h>
# include <linux/tqueue.h>
# include <asm/io.h>
# include <asm/irq.h>
# include <asm/segment.h>
# include <asm/tivomisc.h>
#include <asm/qdma.h>
#include <asm/io.h>
#include <asm/irq.h>

#include <asm/page.h>
#include <asm/dio.h>
extern pte_t *
findPTE(struct mm_struct *mm, unsigned long badaddr);
static unsigned char *
Translate(U32 vaddr){
  pte_t *pte;
  U32 res;
  pte = findPTE(current->mm,vaddr);
  res = pte_val(*pte);
  return (unsigned char *)res;
}

#endif






void
DmaChReqDioInit(DmaChReqDioT *me,unsigned char *ptr, int len)
{
  me->bytesLeft = me->bytesTotal = len;
  me->curPtr = (U32)ptr;
}
#ifndef TESTING
static void flush_to_ram(unsigned long start, int len){
     
	unsigned long p = (unsigned long)start & PAGE_MASK;
	unsigned long stop = p + len;
	for (; p < stop; p += 16) {
		asm("dcbf 0,%0" : : "r" (p));
		asm("icbi 0,%0" : : "r" (p));
	}
}
#else
static void flush_to_ram(unsigned long start, int len){}
#endif
bool
DmaChReqDioGet(DmaChReqDioT *me, DmaChReqT *req){
panic("DmaChReqDioGet");
return FALSE;
#if 0
  req->numFrags = 0;
  if (me->bytesLeft == 0)
    return TRUE;
  if (me->bytesLeft == me->bytesTotal){
    int offset = me->curPtr%PAGE_SIZE;
    req->frags[0].buf     = Translate(me->curPtr&PAGE_MASK)+offset;
    req->frags[0].len     = min(me->bytesLeft,PAGE_SIZE - offset);
    flush_to_ram(req->frags[0].buf,PAGE_SIZE);
    req->numFrags = 1;
    me->curPtr += req->frags[0].len;
    me->bytesLeft-=req->frags[0].len;
  }
  if (me->bytesLeft == 0) {
    goto done;
  }
  while(me->bytesLeft >= PAGE_SIZE){
    if (req->numFrags >= MAX_FRAGS-1) {
      goto done;
    }
    req->frags[req->numFrags].buf  = Translate(me->curPtr&PAGE_MASK);
    req->frags[req->numFrags].len  = PAGE_SIZE;
    flush_to_ram(req->frags[req->numFrags].buf,PAGE_SIZE);    
    req->numFrags++;
    me->curPtr += PAGE_SIZE;
    me->bytesLeft -= PAGE_SIZE;
  }
  if (me->bytesLeft > 0){
    req->frags[req->numFrags].buf     = Translate(me->curPtr&PAGE_MASK);
    req->frags[req->numFrags].len     = me->bytesLeft;
    flush_to_ram(req->frags[req->numFrags].buf,PAGE_SIZE);        
    req->numFrags++;
    me->bytesLeft = 0;
  }

  /*  me->bytesLeft == 0 */
  goto done;


 done:
  return FALSE;
#endif
}


void
DmaChReqPrint(DmaChReqT *me){
panic("DmaChReqDioGet");
#if 0
  int i;
  for (i=0;i<me->numFrags;i++){
#ifndef __KERNEL__    
    printf("index %i, buf %p, len %d\n",i,
	   me->frags[i].buf,
	   me->frags[i].len);
#else
    printk("index %i, buf %p, len %d\n",i,
	   me->frags[i].buf,
	   me->frags[i].len);
#endif    
  }
#endif
}
  
#ifdef TESTING
main()
{
  DmaChReqT req;
  DmaChReqDioT reqDio;

  printf("\n\n\n512,8\n");
  DmaChReqDioInit(&reqDio,(unsigned char *)512,8);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }


  printf("\n\n\n512,1024*100\n");
  DmaChReqDioInit(&reqDio,(unsigned char *)512,1024*100);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }

  
  
  printf("\n\n\n512,1024*2\n");
  DmaChReqDioInit(&reqDio,(unsigned char *)512,1024*2);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }

  
  printf("\n\n\n0,1024*\n");
  DmaChReqDioInit(&reqDio,(unsigned char *)0,1024);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }


  printf("\n\n\n1020,4\n");
  DmaChReqDioInit(&reqDio,(unsigned char *)1020,4);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }


  printf("\n\n\n4,1024*1\n");
  DmaChReqDioInit(&reqDio,(unsigned char *)4,1024*1);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }

  
  printf("\n\n\n0,1024*1\n");
  DmaChReqDioInit(&reqDio,0,1024*1);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }


  printf("\n\n\n0,1024*3\n");
  DmaChReqDioInit(&reqDio,0,1024*3);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }


  printf("\n\n\n0,1024*33\n");
  DmaChReqDioInit(&reqDio,0,1024*33);
  while (DmaChReqDioGet(&reqDio, &req)==FALSE) {
    DmaChReqPrint(&req);
  }

  
}
#endif





