#ifndef _LINUX_IDE_TIVO_H
#define _LINUX_IDE_TIVO_H

/* Enable some simple profiling additions */
#define IDETIVO_PROFILE

struct idetivo_driver_info; 
struct idetivo_driver_info *idetivo_init_driver_info(void);

struct idetivo_drive_info; 
struct idetivo_drive_info *idetivo_init_drive_info(void);

struct FsIovec *copy_and_translate(struct FsIovec *buf, int buf_len,
                                          int *new_buf_len, int ifwrite);

typedef struct FsIovec {
    void *pb;
    unsigned int cb;
} FsIovec;

#define INFINITE_DEADLINE ((long long)(0x7fffffffffffffff))

typedef struct FsIoRequest {
    unsigned long sector;
    unsigned int num_sectors;
    long long deadline;  /* in usec since Jan 1, 1970 (TmkTime / 1000) */
} FsIoRequest;

#endif
